{{
    Copyright 2009 Vassilis Varveropoulos (vassilis@vrhome.net)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}}

CON
  MaxFilterLength = 100

VAR
  long buffer[MaxFilterLength]
  long bufferPntr
  long accum
  long length

PUB init(_length) | n
  ' Initialize filter length
  if _length =< MaxFilterLength
    length := _length
  else
    length := MaxFilterLength
  ' Zero out buffer
  repeat n from 0 to length-1
    buffer[n] := 0
  ' Init other vars
  accum := 0
  bufferPntr := 0  

PUB update(sample) | lastSample
  ' Read last sample
  lastSample := buffer[bufferPntr]    
  ' Add new sample in buffer
  buffer[bufferPntr++] := sample
  if bufferPntr == length
    bufferPntr := 0
  ' Update accum
  accum := accum - lastSample + sample
  ' Done 
  return accum / length  
      